/**
 * Note about import java classes.
 * Use Packages.packageName to refer to a java packages.
 * ie, Packages.sagex.api.Global.GetOS();
 * 
 * You can create local vars for these, such as,
 * var global = Packages.sagex.api.Global;
 * global.GetOS();
 * 
 */

var ver = "201610241";
var debug = true;
var millisToUTC = 4 * 60 * 60 * 1000;	// TODO Fix this hack.

function Echo(name) {
	return name;
}

function javascriptVersion() {
	return ver;
}

function toJavaArrayList(list) {
	arrayList = new Packages.java.util.ArrayList();
	if (list==null) return arrayList;
	length = list.length;
	if (length==0) return arrayList;
	for (i=0; i<length; i++) {
		arrayList.add(list[i]);
	}
	return arrayList;
}

// Returns an array of names.
function GetNames(mediaFiles) {
	var names=[];
		
	if (mediaFiles==null)
		return names;
	
	var len = mediaFiles.length;
	for (i=0; i<len; i++) {
		names[i] = Packages.sagex.api.AiringAPI.GetAiringTitle(mediaFiles[i]);
		//debugLog("GetMediaFilesNames: " + names[i]);
	}
	return names;
}

function GetAiringIdNames(mediaFiles) {
	var names=[];
		
	if (mediaFiles==null)
		return names;
	
	var len = mediaFiles.length;
	for (i=0; i<len; i++) {
		names[i] = Packages.sagex.api.AiringAPI.GetAiringID(mediaFiles[i]) + "-" + Packages.sagex.api.AiringAPI.GetAiringTitle(mediaFiles[i]);
	}
	return toJavaArrayList(names);
}

function GetMediaFileIdNames(mediaFiles) {
	var names=[];
		
	if (mediaFiles==null)
		return names;
	
	var len = mediaFiles.length;
	for (i=0; i<len; i++) {
		names[i] = Packages.sagex.api.MediaFileAPI.GetMediaFileID(mediaFiles[i]) + "-" + Packages.sagex.api.MediaFileAPI.GetMediaTitle(mediaFiles[i]);
	}
	return names;
}

function GetMediaFiles() {
	return Packages.sagex.api.Database.FilterByBoolMethod(Packages.sagex.api.MediaFileAPI.GetMediaFiles("T"), "IsCompleteRecording", true);
}

function GetMediaFilesWithMask(mask) {
	return Packages.sagex.api.Database.FilterByBoolMethod(Packages.sagex.api.MediaFileAPI.GetMediaFiles(mask), "IsCompleteRecording", true);	
}

function GetAiringsForMediaFiles(mask) {
	var mediaFiles = Packages.sagex.api.Database.SortLexical(GetMediaFilesWithMask(mask), false, "GetAiringTitle");
	
	if (mediaFiles==null)
		return null;
	
	var len = mediaFiles.length;
	var airings = [];
	
	for (i=0; i<len; i++) {
		airings[i] = Packages.sagex.api.MediaFileAPI.GetMediaFileAiring(mediaFiles[i]);
	}
	
	return airings;
}

// Returns a list of names order by similarity.
function GetClosestRecordingNames(title, max) {
	var names = [];
	pairs = getMostSimilarRecordedPairs(title);
	length = pairs.length;
	//debugLog("*************************************LENGTH="+length);
	for (i=0; i<length && i<max; i++) {
		thisPair = pairs[i];
		debugLog("title and similarity="+Packages.sagex.api.ShowAPI.GetShowTitle(thisPair.airing)+":"+thisPair.similarity);
		if (thisPair.similarity > 0)
			names.push(Packages.sagex.api.ShowAPI.GetShowTitle(thisPair.airing));
	}
	return names;
}

/*
You can have an array of objects like this:

var People = [
    {Name: "Name", Surname: "Surname"},
    {Name:"AAA", Surname:"ZZZ"},
    {Name: "Name", Surname: "AAA"}
];

...and it will work when you do:

People.sort(dynamicSort("Name"));
People.sort(dynamicSort("Surname"));
People.sort(dynamicSort("-Surname"));
*/
function dynamicSort(property) {
    var sortOrder = 1;
    if(property[0] === "-") {
        sortOrder = -1;
        property = property.substr(1);
    }
    return function (a,b) {
        var result = (a[property] < b[property]) ? -1 : (a[property] > b[property]) ? 1 : 0;
        return result * sortOrder;
    }
}

// title is a String and airings is an array.
function getMostSimilar(title, airings) {
	
	if (airings==null || title==null)
		return null;
	
	length = airings.length;
	if (length==0)
		return null;

	var pairs = [];
	
	for (i=0; i<length; i++) {
		var airingAndSimilarity = new Object();
		airingAndSimilarity.airing = airings[i];
		airingAndSimilarity.similarity = Packages.sagex.phoenix.util.Similarity.getInstance().compareStrings(title, Packages.sagex.api.ShowAPI.GetShowTitle(airings[i]));		
		pairs[i] = airingAndSimilarity;
	}
	
	return pairs.sort(dynamicSort("-similarity"));
}

function mediaFilesWithUniqueTitles(allAirings) {
	if (allAirings==null)
		return null;
	
	length = allAirings.length;
	if (length==0)
		return null;

	var airings = [];
	var titles = [];
	
	for (i=0; i<length; i++) {
		thisTitle = Packages.sagex.api.ShowAPI.GetShowTitle(allAirings[i]);
		if (titles.indexOf(thisTitle) < 0) {
			airings.push(allAirings[i]);
			titles.push(thisTitle);
		}
	}
	
	return airings;
}

function getMostSimilarRecordedPairs(title) {
	pairs = getMostSimilar(title, mediaFilesWithUniqueTitles(GetMediaFiles()));
	//length = pairs.length;
	//debugLog("*************************************LENGTH="+length);
	//for (i=0; i<length && i<max; i++) {
	//	thisPair = pairs[i];
	//	debugLog("title and similarity="+Packages.sagex.api.ShowAPI.GetShowTitle(thisPair.airing)+":"+thisPair.similarity);	
	//}
	
	return pairs;
}

function simTest() {
	pairs = getMostSimilar("trek", mediaFilesWithUniqueTitles(GetMediaFiles()));
	length = pairs.length;
	debugLog("*************************************LENGTH="+length);
	for (i=0; i<length; i++) {
		thisPair = pairs[i];
		debugLog("title and similarity="+Packages.sagex.api.ShowAPI.GetShowTitle(thisPair.airing)+":"+thisPair.similarity);	
	}
}

function GetUpcomingMovies() {
	movieList = new Packages.java.util.ArrayList();
	altMovieList = new Packages.java.util.ArrayList();
	combinedMovieList = new Packages.java.util.ArrayList();
	
	movieList = Packages.sagex.api.Database.SearchSelectedFields("Movie", false, false, false, false, false, true, false, false, false, false,"T");
	altMovieList = Packages.sagex.api.Database.SearchSelectedFields(Packages.sagex.api.Configuration.GetServerProperty("alternate_movie_category", "Film" ), false, false, false, false, false, true, false, false, false, false,"T");
	//combinedMovieList = Packages.sagex.api.Database.FilterByRange(Packages.java.util.List.toArray(Packages.sagex.api.Database.DataUnion(movieList,altMovieList)), "GetAiringStartTime", Packages.sagex.api.Utility,Time(), 2*Packages.sagex.api.Utility.Time(), true);
	combinedMovieList = Packages.sagex.api.Database.FilterByRange(Packages.sagex.api.Database.DataUnion(movieList,altMovieList), "GetAiringStartTime", Packages.sagex.api.Utility.Time(), 2*Packages.sagex.api.Utility.Time(), true);
	filteredMovieList = Packages.sagex.api.Database.FilterByMethod(Packages.sagex.api.Database.FilterByBoolMethod(combinedMovieList, "IsChannelViewable", true), "GetStationID", 0, false);
	return GetAiringIdNames(filteredMovieList);
}

function GetRecordedMovies() {
	movieList = new Packages.java.util.ArrayList();
	altMovieList = new Packages.java.util.ArrayList();
	combinedMovieList = new Packages.java.util.ArrayList();
	
	movieList = Packages.sagex.api.Database.FilterByMethod(Packages.sagex.api.Database.FilterByBoolMethod(Packages.sagex.api.MediaFileAPI.GetMediaFiles("TV"), "IsCompleteRecording", true), "GetShowCategory", "Movie", true);
	altMovieList = Packages.sagex.api.Database.FilterByMethod(Packages.sagex.api.Database.FilterByBoolMethod(Packages.sagex.api.MediaFileAPI.GetMediaFiles("TV"), "IsCompleteRecording", true), "GetShowCategory", Packages.sagex.api.Configuration.GetServerProperty("alternate_movie_category", "Film" ), true);
	combinedMovieList = Packages.sagex.api.Database.DataUnion(movieList,altMovieList);
	return GetAiringIdNames(combinedMovieList);
}

function GetRecordedMoviesAirings() {
	movieList = new Packages.java.util.ArrayList();
	altMovieList = new Packages.java.util.ArrayList();
	combinedMovieList = new Packages.java.util.ArrayList();
	
	movieList = Packages.sagex.api.Database.FilterByMethod(Packages.sagex.api.Database.FilterByBoolMethod(Packages.sagex.api.MediaFileAPI.GetMediaFiles("TV"), "IsCompleteRecording", true), "GetShowCategory", "Movie", true);
	altMovieList = Packages.sagex.api.Database.FilterByMethod(Packages.sagex.api.Database.FilterByBoolMethod(Packages.sagex.api.MediaFileAPI.GetMediaFiles("TV"), "IsCompleteRecording", true), "GetShowCategory", Packages.sagex.api.Configuration.GetServerProperty("alternate_movie_category", "Film" ), true);
	return Packages.sagex.api.Database.DataUnion(movieList,altMovieList);
}

function GetSpecialAirings() {

	airings = new Packages.java.util.ArrayList();
	specials = new Packages.java.util.ArrayList();
	
	airings = Packages.sagex.api.Database.GetAiringsOnViewableChannelsAtTime(Packages.sagex.api.Utility.Time(), Packages.sagex.api.Utility.Time()*2, false);
	airings = Packages.sagex.api.Database.FilterByBoolMethod(airings, "IsShowFirstRun", true);
	airings = Packages.sagex.api.Database.FilterByMethod(airings, "GetStationID", 0, false);
	airings = Packages.sagex.api.Database.Sort(airings, false, "GetAiringStartTime");
	
	if (airings==null)
		return null;
	
	length = airings.length;
	if (length==0)
		return null;
	
	for (i=0; i<length; i++) {
		airing = airings[i];
		extraDetails = Packages.sagex.api.AiringAPI.GetExtraAiringDetails(airing);
		isPremiere = Packages.sagex.api.Utility.StringIndexOf(extraDetails,"Premiere") != -1;
		isFinale = Packages.sagex.api.Utility.StringIndexOf(extraDetails,"Finale") != -1;
		//isSpecial = Packages.java.lang.String.matches(Packages.sagex.api.ShowAPI.GetShowExternalID(airing),".*000[1-4]$") && !isPremiere && !isFinale;
		str = Packages.sagex.api.ShowAPI.GetShowExternalID(airing);
		isSpecial = str.matches(".*000[1-4]$") && !isPremiere && !isFinale;
		if (isPremiere || isFinale || isSpecial) specials.add(airing);
	}
	
	return GetAiringIdNames(specials);
}

function GetRecordedMoviesWithGenre(genre) {
	
	filteredAirings = [];
	if (genre == null) return null;
	genre = genre.toLowerCase();
	
	airings = GetRecordedMoviesAirings();
	if (airings==null) return null;
	
	length = airings.length;
	if (length ==0) return null;
	
	for (i=0; i<length; i++) {
		category = Packages.sagex.api.ShowAPI.GetShowCategory(airings[i]);
		subCategory = Packages.sagex.api.ShowAPI.GetShowSubCategory(airings[i]);
		if (genre==category.toLowerCase() || genre==subCategory.toLowerCase()) 
			filteredAirings.push(airings[i]);
	}
	
	return GetAiringIdNames(filteredAirings);
}

function GetRecordingsWithGenre(genre) {
	
	filteredAirings = [];
	if (genre == null) return null;
	genre = genre.toLowerCase();
	
	airings = GetMediaFilesWithMask("TV");
	if (airings==null) return null;
	
	length = airings.length;
	if (length ==0) return null;
	
	for (i=0; i<length; i++) {
		category = Packages.sagex.api.ShowAPI.GetShowCategory(airings[i]);
		subCategory = Packages.sagex.api.ShowAPI.GetShowSubCategory(airings[i]);
		if (genre==category.toLowerCase() || genre==subCategory.toLowerCase()) 
			filteredAirings.push(airings[i]);
	}
	
	return GetAiringIdNames(filteredAirings);
}

function GetAiringIdForMediaFiles(mask) {
	return GetAiringIdNames(GetAiringsForMediaFiles(mask));
}

/*
function SortIdNameByMethod(idNames, method, descending) {
	
	if (idNames==null)
		return null;
	
	if (method==null)
		method = "GetAiringTitle";
	
	// First get all Airings into airings.
	var len = idNames.length;
	var airings = new Packages.java.util.ArrayList();
	
	for (i=0; i<len; i++) {
		var res = idNames[i].split("-");
		airingId = res[0];
		airing = Packages.sagex.api.AiringAPI.GetAiringForID(airingId);
		airings.add(airing);
	}
	
	// Now sort them according to 'method'.
	var sortedAirings = Packages.sagex.api.Database.SortLexical(airings, descending, method);
	
	// Convert to Id-Name.
	return GetAiringIdNames(sortedAirings);
}
*/

function GetNewestMediaFiles(max) {
		
	var allMediaFiles = [];
	var mediaFiles = [];
	var mf = [];
	
	debugLog("GetNewestMediaFiles: Enter.");

	// slice doesn't like the results returned by GetMediaFiles. Convert to a "real" JavaScript array.
	mf = Packages.sagex.api.Database.Sort(GetMediaFiles(), true, "GetAiringStartTime");
	
	if (mf==null) {
		debugLog("GetNewestMediaFiles: null mf.");
		return allMediaFiles;
	}
	
	mfLen = mf.length;
	
	if (mfLen==0) {
		debugLog("GetNewestMediaFiles: No media files returned.");
		return allMediaFiles;
	}
	
	for (i=0; i<mfLen; i++) {		
		allMediaFiles.push(mf[i]);
	}
	
	debugLog("GetNewestMediaFiles: allMediaFiles length = " + allMediaFiles.length);
	
	if (allMediaFiles.length <= max) {
		mediaFiles = allMediaFiles;
	} else {
		mediaFiles = allMediaFiles.slice(0,max);
	}
	
	debugLog("GetNewestMediaFiles: Returning.");
	return mediaFiles;
}

function GetNewestMediaFilesNames(max) {	
	return GetNames(GetNewestMediaFiles(max));
}

function GetNewestMediaFilesIdNames(max) {	
	return GetAiringIdNames(GetNewestMediaFiles(max));
}

function GetMediaFilesNames() {
	return GetNames(GetMediaFiles());
}

function GetCurrentlyRecordingMediaFiles() {
	return Packages.sagex.api.Global.GetCurrentlyRecordingMediaFiles();
}

function GetCurrentlyRecordingMediaFilesNames() {
	return GetNames(GetCurrentlyRecordingMediaFiles());
}

function GetCurrentlyRecordingMediaFilesIdNames() {
	return GetAiringIdNames(GetCurrentlyRecordingMediaFiles());
}

function GetUpcomingRecordings() {
	return Packages.sagex.api.Database.Sort(Packages.sagex.api.Global.GetScheduledRecordings(),false,"GetAiringStartTime");
}

function GetUpcomingRecordingsNames() {
	return GetNames(GetUpcomingRecordings());
}

function IsRecording() {
	mediaFiles = Packages.sagex.api.Global.GetCurrentlyRecordingMediaFiles();
	return mediaFiles==null ? false : mediaFiles.length > 0;
}

function GetConflicts() {
	return Packages.sagex.api.Database.Sort(Packages.sagex.api.Global.GetAiringsThatWontBeRecorded(true),false,"GetAiringStartTime");
}

function GetConflictsNames() {
	return GetNames(GetConflicts());
}

function GetRecordingOnDay(m) {
	var millis = new Number(m);
	var upcomingRecordings = [];
	
	debugLog("GetRecordingOnDay: millis=" + millis);
	debugLog("getRecordingOnDay: Timezone=" + Packages.sagex.api.Configuration.GetTimeZone());
	
	upcomingRecordings = GetUpcomingRecordings();

	if (upcomingRecordings==null || upcomingRecordings.length == 0)
		return upcomingRecordings;
	
	millis = millis + millisToUTC;
	var date = new Date(millis);

	var targetDate = Packages.sagex.api.Utility.DateFormat("yyyyMMdd", date.getTime());
	debugLog("GetRecordingOnDay: targetDate=" + targetDate);

	var recordingOnDate = [];
	var length = upcomingRecordings.length;
	
	for (i=0; i<length; i++) {
		if (targetDate == Packages.sagex.api.Utility.DateFormat("yyyyMMdd", Packages.sagex.api.AiringAPI.GetAiringStartTime(upcomingRecordings[i]))) {
			recordingOnDate.push(upcomingRecordings[i]);
		}
	}
	
	return recordingOnDate;
}

function GetSuggestedIntelligentRecordings() {
	return Packages.sagex.api.Database.Sort(Packages.sagex.api.Global.GetSuggestedIntelligentRecordings(),false,"GetAiringStartTime");
}

function GetSuggestedIntelligentRecordingsNames() {
	return GetNames(GetSuggestedIntelligentRecordings());
}

function GetSuggestedIntelligentRecordingsIdNames() {
	return GetAiringIdNames(GetSuggestedIntelligentRecordings());	
}

function GetRecordingOnDayNames(millis) {
	return GetNames(GetRecordingOnDay(millis));
}

function GetRecordingOnDayIdNames(millis) {
	return GetAiringNames(GetRecordingOnDay(millis));
}

function GetRecordedOnDay(m) {
	var millis = new Number(m);
	var recordings = [];
	
	debugLog("GetRecordedOnDay: millis=" + millis);
	debugLog("GetRecordedOnDay: Timezone=" + Packages.sagex.api.Configuration.GetTimeZone());	
	
	recordings = GetMediaFiles();

	if (recordings==null || recordings.length == 0)
		return recordings;
	
	millis = millis + millisToUTC;
	var date = new Date(millis);
	
	var targetDate = Packages.sagex.api.Utility.DateFormat("yyyyMMdd", date.getTime());
	debugLog("GetRecordedOnDay: targetDate=" + targetDate);

	var recordedOnDate = [];
	var length = recordings.length;
	
	for (i=0; i<length; i++) {
			if (targetDate == Packages.sagex.api.Utility.DateFormat("yyyyMMdd", Packages.sagex.api.AiringAPI.GetAiringStartTime(recordings[i]))) {
				recordedOnDate.push(recordings[i]);
			}
	}
	
	return recordedOnDate;
}

function GetRecordedOnDayNames(millis) {
	return GetNames(GetRecordedOnDay(millis));
}

function GetRecordedOnDayIdNames(millis) {
	return GetAiringIdNames(GetRecordedOnDay(millis));
}

// Get system messages with level 'c'.
function GetSystemMessages(c) {
	var code = new Number(c);
	var messageObjects = [];
	var messages = [];
	messageObjects = Packages.sagex.api.SystemMessageAPI.GetSystemMessages();
	
	if (messageObjects==null)
		return messages;
	
	var length = messageObjects.length;
	
	if (length == 0)
		return messages;

	for (i=0; i<length; i++) {
		if (code == Packages.sagex.api.SystemMessageAPI.GetSystemMessageLevel(messageObjects[i])) {
			messages.push(Packages.sagex.api.SystemMessageAPI.GetSystemMessageString(messageObjects[i]));
		}
	}

	return messages;	
}

// Total amount of memory in the JVM.
function GetTotalHeapMemory() {
	rt = Packages.java.lang.Runtime.getRuntime();
	return rt.totalMemory();
}

// Amount of free memory in the JVM.
function GetFreeHeapMemory() {
	rt = Packages.java.lang.Runtime.getRuntime();
	return rt.freeMemory();
}

// Max amount of memory that the JVM will attempt to use.
function GetMaxHeapMemory() {
	rt = Packages.java.lang.Runtime.getRuntime();
	return rt.maxMemory();
}

function GetUsedHeapMemory() {
	return GetTotalHeapMemory() - GetFreeHeapMemory();
}

function GetPercentUsedHeapMemory() {
	return Math.round((GetUsedHeapMemory() / GetMaxHeapMemory()) * 100);
}

function GetAllCategories() {
	return Packages.sagex.api.Database.GetAllCategories();
}

function RunGarbageCollector() {
	Packages.java.lang.System.gc();
}

// Returns all Airings with the given genre in the Category field.
function GetAiringsWithGenre(genre) {
	return Packages.sagex.api.Database.SearchSelectedFields(genre, false, false, false, false, false, true, false, false, false, false);
}

// Returns all current Television Id-Airings with the given title in the Title or Episode fields.
function GetAiringsWithShowTitle(title) {
	var allAirings = [];
	title = title.replaceAll("_", " ");
	debugLog("GetAiringsWithShowTitle: title="+title);
	allAirings = Packages.sagex.api.Database.SearchSelectedFields(title, false, true, true, false, false, false, false, false, false, false, "T");
	debugLog("GetAiringsWithShowTitle: length="+allAirings.length);
	if (allAirings.length == 0) return;
	//debugLog("EXTERNAL ID="+Packages.sagex.api.ShowAPI.GetShowExternalID(Packages.sagex.api.AiringAPI.GetShow(allAirings[0])));
	return GetCurrentIdAiringsForShow(Packages.sagex.api.ShowAPI.GetShowExternalID(Packages.sagex.api.AiringAPI.GetShow(allAirings[0])));
}

// Returns "AiringId-AiringTitle"
function GetAiringIdNamesWithGenre(genre) {
	return GetAiringIdNames(GetAiringsWithGenre(genre));
}

// Returns "AiringId-AiringTitle"
function GetIdNamesForShowTitle(title) {
	return GetAiringsWithShowTitle(title);
}

// Returns just the Show names.
function GetShowNamesWithGenre(genre) {
	map = Packages.sagex.api.Database.GroupByMethod(GetAiringsWithGenre(genre), "GetShowTitle");
	var keys = [];
	for (var key in map) {
		keys.push(key);
	}
	return keys;
}

// Returns the ShowExternalID for all shows with the given genre in the Category field.
function GetShowIdsWithGenre(genre) {
	map = Packages.sagex.api.Database.GroupByMethod(GetAiringsWithGenre(genre), "GetShowExternalID");
	var keys = [];
	for (var key in map) {
		debugLog("ShowExternalID="+key);
		keys.push(key);
	}
	return keys;
}

function GetIdAndShowWithGenre(genre) {
	ids = GetShowIdsWithGenre(genre);
	var length = ids.length;
	
	if (length==0) {
		return ids;
	}
	
	var idAndTitle = [];
	
	for (i=0; i<length; i++) {
		title = Packages.sagex.api.ShowAPI.GetShowTitle(Packages.sagex.api.ShowAPI.GetShowForExternalID(ids[i]));
		idAndTitle.push(ids[i]+"-"+title);
	}
	
	return idAndTitle;
}

function GetAiringCategory(id) {
	return Packages.sagex.api.ShowAPI.GetShowCategory(Packages.sagex.api.AiringAPI.GetAiringForID(id));
}

function GetAiringSubCategory(id) {
	return Packages.sagex.api.ShowAPI.GetShowSubCategory(Packages.sagex.api.AiringAPI.GetAiringForID(id));
}

function GetAllAiringsForShowId(showId) {
	title = Packages.sagex.api.ShowAPI.GetShowTitle(Packages.sagex.api.ShowAPI.GetShowForExternalID(showId));
	return Packages.sagex.api.Database.SearchSelectedExactFields(title, false, true, false, false, false, false, false, false, false, false, "T");
}

function GetFutureIdAiringsForShow(showId) {
	var allAirings = [];
	var futureAirings = [];
	allAirings = GetAllAiringsForShowId(showId);
	now = Packages.sagex.api.Utility.Time();
	futureAirings = Packages.sagex.api.Database.FilterByRange(allAirings, "GetAiringEndTime", now, 2*now, true);
	return GetAiringIdNames(futureAirings);
}

function GetPastIdAiringsForShow(showId) {
	var allAirings = [];
	var pastAirings = [];
	allAirings = GetAllAiringsForShowId(showId);
	now = Packages.sagex.api.Utility.Time();
	pastAirings = Packages.sagex.api.Database.FilterByRange(allAirings, "GetAiringEndTime", 0, now, true);
	return GetAiringIdNames(pastAirings);
}

function GetCurrentIdAiringsForShow(showId) {
	var allAirings = [];
	var currentAirings = [];
	
	allAirings = GetAllAiringsForShowId(showId);
	
	var len = allAirings.length;

	if (len==0) {
		return allAirings;
	}
	
	for (i=0; i<len; i++) {	
		if (Packages.sagex.api.AiringAPI.GetMediaFileForAiring(allAirings[i]) != null) {
			currentAirings.push(allAirings[i]);
		}
	}	
	return GetAiringIdNames(currentAirings);
}

function getAiringsForIds(idString) {
	var airings = [];
	var ids = [];

	if (idString.length==0)
		return airings;
	
	ids = idString.split("-");
	
	length = ids.length;

	if (length==0)
		return airings;
	
	for (i=0; i<length; i++) {			
		airings.push(Packages.sagex.api.AiringAPI.GetAiringForID(ids[i]));
	}
	
	return airings;
}

function FilterAiringsByBoolMethod(ids, method, match) {
	var allAirings = [];
	var filteredAirings = new Packages.java.util.ArrayList();
	var idNames = [];
	var allAiringsList = new Packages.java.util.ArrayList();
	
	allAirings = getAiringsForIds(ids);
	debugLog("FilterAiringsByBoolMethod: allAirings=" + allAirings.length);
	if (allAirings.length==0)
		return idNames;

	// Convert to Java ArrayList for FilterByBoolMethod.
	for (i=0; i<allAirings.length; i++)	{
		allAiringsList.add(allAirings[i]);
	}
	
	filteredAirings = Packages.sagex.api.Database.FilterByBoolMethod(allAiringsList, method, match=="true");
	
	if (filteredAirings==null) {
		debugLog("FilterAiringsByBoolMethod: null returned from FilterByBoolMethod:" + method + ":" + match);
		return idNames;
	}
	
	length = filteredAirings.length;
	debugLog("FilterAiringsByBoolMethod: filteredAirings=" + length);
	if (length==0)
		return idNames;
	
	return GetAiringIdNames(filteredAirings);
}

function SortAiringsByMethod(ids, method, descending) {
	var allAirings = [];
	var sortedAirings = new Packages.java.util.ArrayList();
	var allAiringsList = new Packages.java.util.ArrayList();
	
	if (debug) debugLog("ids=" + ids);
	if (debug) debugLog("method=" + method);
	if (debug) debugLog("descending=" + descending);
	
	allAirings = getAiringsForIds(ids);
	if (debug) debugLog("SortAiringsByMethod: allAirings=" + allAirings.length);
	if (allAirings.length==0) {
		debugLog("SortAiringsByMethod: allAirings length = 0");
		return null;
	}

	// Convert to Java ArrayList for SortLexical.
	for (i=0; i<allAirings.length; i++)	{
		allAiringsList.add(allAirings[i]);
	}
	
	if (debug) PrintFirstAndLast(allAiringsList, "Before sort "+method+":"+descending);
	if (debug) debugLog("Before allAiringsList=" + allAiringsList);	
	sortedAirings = Packages.sagex.api.Database.SortLexical(allAiringsList, descending=="true", method);
	if (debug) PrintFirstAndLast(sortedAirings, "After sort "+method);
	
	if (sortedAirings==null) {
		debugLog("SortAiringsByMethod: null returned from SortLexical: " + method + ":" + descending);
		return null;
	}
	
	if (debug) debugLog("After sortedAirings=" + sortedAirings);
	
	length = sortedAirings.length;
	if (debug) debugLog("SortAiringsByMethod: sortedAirings=" + length);
	
	if (length==0) {
		debugLog("SortAiringsByMethod: sortedAirings length = 0");
		return null;
	}
	 
	return GetAiringIdNames(sortedAirings);
}

function SortAiringsBySeasonEpisode(ids, descending) {
	var allAirings = [];
	var sortedAirings = new Packages.java.util.ArrayList();
	var allAiringsList = new Packages.java.util.ArrayList();
	
	if (debug) debugLog("ids=" + ids);
	if (debug) debugLog("descending=" + descending);
	
	allAirings = getAiringsForIds(ids);
	if (debug) debugLog("SortAiringsBySeasonEpisode: allAirings=" + allAirings.length);
	if (allAirings.length==0) {
		debugLog("SortAiringsBySeasonEpisode: allAirings length = 0");
		return null;
	}

	// Convert to Java ArrayList for Sort.
	for (i=0; i<allAirings.length; i++)	{
		allAiringsList.add(allAirings[i]);
	}	
	
	sortedAirings = Packages.sagex.api.Database.Sort(allAiringsList, descending=="true", "GetOriginalAiringDate");
	sortedAirings = Packages.sagex.api.Database.Sort(sortedAirings, descending=="true", "GetShowEpisodeNumber");
	sortedAirings = Packages.sagex.api.Database.Sort(sortedAirings, descending=="true", "GetShowSeasonNumber");
	
	if (sortedAirings==null) {
		debugLog("SortAiringsBySeasonEpisode: null returned from Sort: " + ":" + descending);
		return null;
	}
	
	if (debug) debugLog("After sortedAirings=" + sortedAirings);
	
	length = sortedAirings.length;
	if (debug) debugLog("SortAiringsBySeasonEpisode: sortedAirings=" + length);
	
	if (length==0) {
		debugLog("SortAiringsBySeasonEpisode: sortedAirings length = 0");
		return null;
	}
	 
	return GetAiringIdNames(sortedAirings);	
}

function GetCategoryForAirings(ids) {
	var allAirings = [];
	var categories = [];
	
	if (debug) debugLog("GetCategoryForAirings: ids=" + ids);
	
	allAirings = getAiringsForIds(ids);

	if (allAirings.length==0) {
		debugLog("GetCategoryForAirings: allAirings length = 0");
		return null;
	}

    for	(i=0; i<length; i++) {
		categories[i] = Packages.sagex.api.ShowAPI.GetShowCategory(allAirings[i]);
	}  

	return 	categories;
}

function GetSubCategoryForAirings(ids) {
	var allAirings = [];
	var categories = [];
	
	if (debug) debugLog("GetSubCategoryForAirings: ids=" + ids);
	
	allAirings = getAiringsForIds(ids);

	if (allAirings.length==0) {
		debugLog("GetSubCategoryForAirings: allAirings length = 0");
		return null;
	}

    for	(i=0; i<length; i++) {
		categories[i] = Packages.sagex.api.ShowAPI.GetShowSubCategory(allAirings[i]);
	}  

	return categories;
}

function GetEpisodeTitleForAirings(ids) {
	var allAirings = [];
	var titles = [];
	
	if (debug) debugLog("GetEpisodeTitleForAirings: ids=" + ids);
	
	allAirings = getAiringsForIds(ids);

	if (allAirings.length==0) {
		debugLog("GetEpisodeTitleForAirings: allAirings length = 0");
		return null;
	}

    for	(i=0; i<length; i++) {
		title = Packages.sagex.api.ShowAPI.GetShowEpisode(allAirings[i]);
		if (title==null || title=="")
			title = Packages.sagex.api.AiringAPI.GetAiringTitle(allAirings[i]);
		titles[i] = title;
	}  

	return titles;
}

function GetShowTitleForAirings(ids) {
	var allAirings = [];
	var titles = [];
	
	if (debug) debugLog("GetShowTitleForAirings: ids=" + ids);
	
	allAirings = getAiringsForIds(ids);

	if (allAirings.length==0) {
		debugLog("GetShowTitleForAirings: allAirings length = 0");
		return null;
	}

    for	(i=0; i<length; i++) {
		titles[i] = Packages.sagex.api.AiringAPI.GetAiringTitle(allAirings[i]);
	}  

	return titles;
}

function PrintFirstAndLast(airings, message) {
	debugLog(message);
	if (airings==null) {
		debugLog("PrintFirstAndLast: null airings");
		return;
	}
	len = airings.length;
	if (len>0) PrintAiringInfo(airings[0]);
	if (len>1) PrintAiringInfo(airings[len-1]);
}

function PrintAiringInfo(airing) {
	airingName = Packages.sagex.api.AiringAPI.GetAiringTitle(airing);
	episodeName = Packages.sagex.api.ShowAPI.GetShowEpisode(airing);
	debugLog("Title:Episode = " + airingName + ":" + episodeName);
}

function SetAiringWatched(airId) {
	Packages.sagex.api.AiringAPI.SetWatched(Packages.sagex.api.AiringAPI.GetAiringForID(airId));
}

function ClearAiringWatched(airId) {
	Packages.sagex.api.AiringAPI.ClearWatched(Packages.sagex.api.AiringAPI.GetAiringForID(airId));
}

function SetAiringDontLike(airId) {
	Packages.sagex.api.AiringAPI.SetDontLike(Packages.sagex.api.AiringAPI.GetAiringForID(airId));
}

function ClearAiringDontLike(airId) {
	Packages.sagex.api.AiringAPI.ClearDontLike(Packages.sagex.api.AiringAPI.GetAiringForID(airId));
}

function AddAiringFavorite(airId) {
	title = Packages.sagex.api.AiringAPI.GetAiringTitle(Packages.sagex.api.AiringAPI.GetAiringForID(airId));
	Packages.sagex.api.FavoriteAPI.AddFavorite(title, false, false, null, null, null, null, null, null, null, null, null, null, null);
}

function RemoveAiringFavorite(airId) {
	Packages.sagex.api.FavoriteAPI.RemoveFavorite(Packages.sagex.api.FavoriteAPI.GetFavoriteForAiring(Packages.sagex.api.AiringAPI.GetAiringForID(airId)));
}

function command(cmd, extender) {
	debugLog("Command:UI="+cmd+":"+extender);
	Packages.sagex.api.Global.SageCommand(new Packages.sagex.UIContext(extender), cmd);
}

function watch(extender, airingId) {
	debugLog("About to watch "+ airingId + " on " + extender);
	command("Pause", extender);	// Needed to wake the UI in case the screen saver is running.
	Packages.sagex.api.MediaPlayerAPI.CloseAndWaitUntilClosed(new Packages.sagex.UIContext(extender));
	var airing = Packages.sagex.api.AiringAPI.GetAiringForID(airingId);
	Packages.sagex.api.MediaPlayerAPI.Watch(new Packages.sagex.UIContext(extender), airing);
	command("TV", extender);
	debugLog("Watch has started for "+ airingId + " on " + extender);
}

function stop(extender) {
	debugLog("About to send stop to " + extender);
	command("Pause", extender);	// Needed to wake the UI in case the screen saver is running.
	//Packages.sagex.api.MediaPlayerAPI.CloseAndWaitUntilClosed(new Packages.sagex.UIContext(extender));
	command("Stop", extender);
}

function pause(extender) {
	debugLog("About to send pause to " + extender);
	command("Pause", extender);	// Needed to wake the UI in case the screen saver is running.
	command("Pause", extender);
}

function GetAiringSeasonAndEpisode(id) {
	var seasonEpisode = [];
	
	seasonEpisode[0] = Packages.sagex.api.ShowAPI.GetShowSeasonNumber(Packages.sagex.api.AiringAPI.GetAiringForID(id));
	seasonEpisode[1] = Packages.sagex.api.ShowAPI.GetShowEpisodeNumber(Packages.sagex.api.AiringAPI.GetAiringForID(id));
	
	return seasonEpisode;
}

function debugLog(message) {
	if (debug) Packages.sagex.api.Global.DebugLog("echoFunctions."+message);
}
